'+--------------------------------------------------------------------------+
'|                                 Boing                                    |
'|                                                                          |
'|             Example of 32-bit OpenGL layered splash screen               |
'|                                                                          |
'+--------------------------------------------------------------------------+
'|                                                                          |
'|                         Author Patrice TERRIER                           |
'|                            copyright(c) 2008                             |
'|                           www.zapsolution.com                            |
'|                        pterrier@zapsolution.com                          |
'|                                                                          |
'+--------------------------------------------------------------------------+
'|                  Project started on : 10-10-2008 (MM-DD-YYYY)            |
'|                        Last revised : 12-16-2014 (MM-DD-YYYY)            |
'+--------------------------------------------------------------------------+

$Dot                    = "."

%AC_SRC_ALPHA           = &H01
%TRUE                   = 1
%FALSE                  = 0
%NULL                   = 0
%ULW_ALPHA              = &H00000002
%WM_USER                = &H400
%MAX_PATH               = 260  ' max. length of full pathname
%SRCCOPY                = &H00CC0020 ' (dword) dest = source
%OBJ_BITMAP             = 7
%BI_RGB                 = 0&
%DIB_RGB_COLORS         = 0 ' color table in RGBs
%CCHDEVICENAME          = 32
%CCHFORMNAME            = 32
%PFD_type_RGBA          = 0
%PFD_DOUBLEBUFFER       = &H00000001
%PFD_DRAW_TO_WINDOW     = &H00000004
%PFD_DRAW_TO_BITMAP     = &H00000008
%PFD_SUPPORT_OPENGL     = &H00000020
%PFD_SUPPORT_GDI        = &H00000010
%AC_SRC_OVER            = &H00
%SW_SHOW                = 5
%WM_DESTROY             = &H2
%WM_CLOSE               = &H10
%HTCAPTION              = 2
%WS_POPUP               = &H80000000
%WS_VISIBLE             = &H10000000
%WS_EX_TOPMOST          = &H00000008
%WS_EX_TOOLWINDOW       = &H00000080
%WS_EX_LAYERED          = &H00080000
%SM_CXSCREEN            = 0
%SM_CYSCREEN            = 1
%VK_ESCAPE              = &H1B&

%GL_LESS                = &H0201
%GL_LEQUAL              = &H0203
%GL_GREATER             = &H0204
%GL_ALWAYS              = &H0207
%GL_DEPTH_BUFFER_BIT    = &H00000100
%GL_COLOR_BUFFER_BIT    = &H00004000
%GL_TRIANGLE_FAN        = &H0006
%GL_QUADS               = &H0007
%GL_ONE                 = 1
%GL_SRC_ALPHA           = &H0302
%GL_ONE_MINUS_SRC_ALPHA = &H0303
%GL_TRUE                = 1
%GL_FALSE               = 0
%GL_UNSIGNED_byte       = &H1401
%GL_FRONT               = &H0404
%GL_LIGHTING            = &H0B50
%GL_COLOR_MATERIAL      = &H0B57
%GL_DEPTH_TEST          = &H0B71
%GL_NORMALIZE           = &H0BA1
%GL_ALPHA_TEST          = &H0BC0
%GL_BLEND               = &H0BE2
%GL_TEXTURE_2D          = &H0DE1
%GL_LIGHT0              = &H4000
%GL_AMBIENT             = &H1200
%GL_DIFFUSE             = &H1201
%GL_POSITION            = &H1203
%GL_MODELVIEW           = &H1700
%GL_TEXTURE             = &H1702
%GL_RGBA                = &H1908
%GL_SMOOTH              = &H1D01
%GL_LINEAR              = &H2601
%GL_TEXTURE_MAG_FILTER  = &H2800
%GL_TEXTURE_MIN_FILTER  = &H2801
%GL_COMPILE             = &H1300

%GLU_SMOOTH             = 100000

%SND_RESOURCE           = &H40004     ' name is a resource name or atom
%SND_ASYNC              = &H1         ' play asynchronously
%UnitPixel              = 2 ' Each unit is one device pixel.

type RGBQUAD
    rgbBlue as byte
    rgbGreen as byte
    rgbRed as byte
    rgbReserved as byte
end type

type BITMAPINFOHEADER
    biSize as dword
    biWidth as long
    biHeight as long
    biPlanes as word
    biBitCount as word
    biCompression as dword
    biSizeImage as dword
    biXPelsPerMeter as long
    biYPelsPerMeter as long
    biClrUsed as dword
    biClrImportant as dword
end type

type MYBITMAPINFO
    bmiHeader as BITMAPINFOHEADER
    bmiColors(256) as RGBQUAD ' Patrice
end type

type RECT
    nLeft as long
    nTop as long
    nRight as long
    nBottom as long
end type

type POINTAPI
    x as long
    y as long
end type

type SIZEL
    cx as long
    cy as long
end type

type tagMSG
    hwnd as dword
    message as dword
    wParam as long
    lParam as long
    time as dword
    pt as POINTAPI
end type

type TPMPARAMS
    cbSize as dword
    rcExclude as RECT
end type

type WNDCLASSEX
    cbSize as dword
    STYLE as dword
    lpfnWndProc as long
    cbClsExtra as long
    cbWndExtra as long
    hInstance as dword
    hIcon as dword
    hCursor as dword
    hbrBackground as dword
    lpszMenuName as asciiz PTR
    lpszClassName as asciiz PTR
    hIconSm as dword
end type

type BITMAP
    bmtype as long
    bmWidth as long
    bmHeight as long
    bmWidthbytes as long
    bmPlanes as word
    bmBitsPixel as word
    bmBits as byte PTR
end type

type PIXELFORMATDESCRIPTOR
    nSize as word
    nVersion as word
    dwFlags as dword
    iPixeltype as byte
    cColorBits as byte
    cRedBits as byte
    cRedShift as byte
    cGreenBits as byte
    cGreenShift as byte
    cBlueBits as byte
    cBlueShift as byte
    cAlphaBits as byte
    cAlphaShift as byte
    cAccumBits as byte
    cAccumRedBits as byte
    cAccumGreenBits as byte
    cAccumBlueBits as byte
    cAccumAlphaBits as byte
    cDepthBits as byte
    cStencilBits as byte
    cAuxBuffers as byte
    iLayertype as byte
    bReserved as byte
    dwLayerMask as dword
    dwVisibleMask as dword
    dwDamageMask as dword
end type

type BLENDFUNCTION
    BlendOp as byte
    BlendFlags as byte
    SourceConstantAlpha as byte
    AlphaFormat as byte
end type

type DEVMODE
    dmDeviceName as asciiz * %CCHDEVICENAME
    dmSpecVersion as word
    dmDriverVersion as word
    dmSize as word
    dmDriverExtra as word
    dmFields as dword
    dmOrientation as integer
    dmPaperSize as integer
    dmPaperLength as integer
    dmPaperWidth as integer
    dmScale as integer
    dmCopies as integer
    dmDefaultSource as integer
    dmPrintQuality as integer
    dmColor as integer
    dmDuplex as integer
    dmYResolution as integer
    dmTTOption as integer
    dmCollate as integer
    dmFormName as asciiz * %CCHFORMNAME
    dmLogPixels as word
    dmBitsPerPel as dword
    dmPelsWidth as dword
    dmPelsHeight as dword
    dmDisplayFlags as dword
    dmDisplayFrequency as dword
    dmICMMethod as dword
    dmICMIntent as dword
    dmMediatype as dword
    dmDithertype as dword
    dmICCManufacturer as dword
    dmICCModel as dword
    dmPanningWidth as dword
    dmPanningHeight as dword
end type

type BBPTEXTURE
    ID       as long
    FullName as asciiz * 260
    Texture  as long
    Square   as long            '// boolean TRUE or FALSE value 
end type

type GdiplusStartupInput
    GdiplusVersion as long             ' Must be 1
    DebugEventCallback as long         ' Ignored on free builds
    SuppressBackgroundThread as long   ' FALSE unless you're prepared to call
                                       ' the hook/unhook functions properly
    SuppressExternalCodecs as long     ' FALSE unless you want GDI+ only to use
                                       ' its internal image codecs.
end type

' Custom types
type COLORbyteS
    B as byte
    G as byte
    R as byte
    A as byte
end type

declare function GdipDeleteGraphics lib "gdiplus.dll" alias "GdipDeleteGraphics" (byval graphics as long) as long
declare function GdipCreateBitmapFromGraphics lib "gdiplus.dll" alias "GdipCreateBitmapFromGraphics" (byval nWidth as long, byval Height as long, byval graphics as long, nBitmap as long) as long
declare function GdipSetInterpolationMode lib "gdiplus.dll" alias "GdipSetInterpolationMode" (byval graphics as long, byval interpolation as long) as long
declare function GdipBitmapGetPixel lib "gdiplus.dll" alias "GdipBitmapGetPixel" (byval nBitmap as long, byval x as long, byval y as long, Colr as long) as long
declare function GdiplusStartup lib "gdiplus.dll" alias "GdiplusStartup" (token as long, inputbuf as GdiplusStartupInput, optional byval outputbuf as long) as long
declare function GdiplusShutdown lib "gdiplus.dll" alias "GdiplusShutdown" (byval token as long) as long
declare function GdipLoadImageFromFile lib "gdiplus.dll" alias "GdipLoadImageFromFile" (zFilName as asciiz, nImage as long) as long
declare function GdipGetImageWidth lib "gdiplus.dll" alias "GdipGetImageWidth" (byval nImage as long, nWidth as long) as long
declare function GdipGetImageHeight lib "gdiplus.dll" alias "GdipGetImageHeight" (byval nImage as long, Height as long) as long
declare function GdipDisposeImage lib "gdiplus.dll" alias "GdipDisposeImage" (byval nImage as long) as long
declare function GdipCreateFromHDC lib "gdiplus.dll" alias "GdipCreateFromHDC" (byval hdc as long, graphics as long) as long
declare function GdipDrawImageRectRectI lib "gdiplus.dll" alias "GdipDrawImageRectRectI" (byval graphics as long, byval nImage as long, byval dstx as long, byval dsty as long, byval dstwidth as long, byval dstheight as long, _
                 byval srcx as long, byval srcy as long, byval srcwidth as long, byval srcheight as long, byval srcUnit as long, _
                 optional byval imageAttributes as long, optional byval pCALLBACK as long, optional byval callbackData as long) as long

declare function SwapBuffers lib "GDI32.DLL" alias "SwapBuffers" (byval hDC as dword) as dword
declare function MyCreateDIBSection lib "GDI32.DLL" alias "CreateDIBSection" (byval hdc as dword, pbmi as MYBITMAPINFO, byval dwUsage as dword, byval ppvBits as dword, byval hSection as dword, byval dwOffset as dword) as dword
declare function BitBlt lib "GDI32.DLL" alias "BitBlt" (byval hDestDC as dword, byval x as long, byval y as long, byval nWidth as long, byval nHeight as long, byval hSrcDC as dword, byval xSrc as long, byval ySrc as long, _
                 byval dwRop as dword) as long
declare function ChoosePixelFormat lib "GDI32.DLL" alias "ChoosePixelFormat" (byval hDC as dword, pPixelFormatDescriptor as PIXELFORMATDESCRIPTOR) as long
declare function CreateCompatibleDC lib "GDI32.DLL" alias "CreateCompatibleDC" (byval hdc as dword) as dword
declare function CreateIC lib "GDI32.DLL" alias "CreateICA" (lpDriverName as asciiz, lpDeviceName as asciiz, lpOutput as asciiz, lpInitData as DEVMODE) as dword
declare function CreateWindowEx lib "USER32.DLL" alias "CreateWindowExA" (byval dwExStyle as dword, lpClassName as asciiz, lpWindowName as asciiz, byval dwStyle as dword, byval x as long, byval y as long, _
                                                                          byval nWidth as long, byval nHeight as long, byval hWndParent as dword, byval hMenu as dword, byval hInstance as dword, lpParam as any) as dword
declare function DefWindowProc lib "USER32.DLL" alias "DefWindowProcA" (byval hWnd as dword, byval uMsg as dword, byval wParam as dword, byval lParam as long) as long
declare function DeleteDC lib "GDI32.DLL" alias "DeleteDC" (byval hdc as dword) as long
declare function DeleteObject lib "GDI32.DLL" alias "DeleteObject" (byval hObject as dword) as long
declare function DestroyWindow lib "USER32.DLL" alias "DestroyWindow" (byval hWnd as dword) as long
declare function DispatchMessage lib "USER32.DLL" alias "DispatchMessageA" (lpMsg as tagMSG) as long
declare function GetClassInfoEx lib "USER32.DLL" alias "GetClassInfoExA" (byval hInst as dword, lpszClass as asciiz, lpWndClass as WNDCLASSEX) as long
declare function GetCurrentObject lib "GDI32.DLL" alias "GetCurrentObject" (byval hdc as dword, byval uObjecttype as dword) as dword
declare function GetDC lib "USER32.DLL" alias "GetDC" (byval hWnd as dword) as dword
declare function GetDIBits lib "GDI32.DLL" alias "GetDIBits" (byval hdc as dword, byval hBitmap as dword, byval nStartScan as dword, byval nNumScans as dword, lpBits as any, lpBI as MYBITMAPINFO, byval wUsage as dword) as long
declare function GetMessage lib "USER32.DLL" alias "GetMessageA" (lpMsg as tagMSG, byval hWnd as dword, byval uMsgFilterMin as dword, byval uMsgFilterMax as dword) as long
declare function GetModuleHandle lib "KERNEL32.DLL" alias "GetModuleHandleA" (lpModuleName as asciiz) as dword
declare function GetObject lib "GDI32.DLL" alias "GetObjectA" (byval hObject as dword, byval nCount as long, lpObject as any) as long
declare function GetSystemMetrics lib "USER32.DLL" alias "GetSystemMetrics" (byval nIndex as long) as long
declare function GetTickCount lib "KERNEL32.DLL" alias "GetTickCount" () as dword
declare function GetWindowRect lib "USER32.DLL" alias "GetWindowRect" (byval hWnd as dword, lpRect as RECT) as long
declare function KillTimer lib "USER32.DLL" alias "KillTimer" (byval hWnd as dword, byval nIDEvent as long) as long
declare function MoveWindow lib "USER32.DLL" alias "MoveWindow" (byval hWnd as dword, byval x as long, byval y as long, byval nWidth as long, byval nHeight as long, byval bRepaint as long) as long
declare function PlaySound lib "WINMM.DLL" alias "PlaySoundA" (lpszName as asciiz, byval hModule as dword, byval dwFlags as dword) as long
declare function RegisterClassEx lib "USER32.DLL" alias "RegisterClassExA" (pcWndClassEx as WNDCLASSEX) as word
declare function ReleaseDC lib "USER32.DLL" alias "ReleaseDC" (byval hWnd as dword, byval hDC as dword) as long
declare function SelectObject lib "GDI32.DLL" alias "SelectObject" (byval hdc as dword, byval hObject as dword) as dword
declare function SetPixelFormat lib "GDI32.DLL" alias "SetPixelFormat" (byval hDC as dword, byval n as long, pcPixelFormatDescriptor as PIXELFORMATDESCRIPTOR) as long
declare function SetRect lib "USER32.DLL" alias "SetRect" (lpRect as RECT, byval X1 as long, byval Y1 as long, byval X2 as long, byval Y2 as long) as long
declare function SetTimer lib "USER32.DLL" alias "SetTimer" (byval hWnd as dword, byval nIDEvent as long, byval uElapse as dword, byval lpTimerFunc as long) as long
declare function ShowWindow lib "USER32.DLL" alias "ShowWindow" (byval hWnd as dword, byval nCmdShow as long) as long
declare function TrackPopupMenuEx lib "USER32.DLL" alias "TrackPopupMenuEx" (byval hMenu as dword, byval uFlags as dword, byval x as long, byval y as long, byval hWnd as dword, lpTPMParams as TPMPARAMS) as long
declare function TranslateMessage lib "USER32.DLL" alias "TranslateMessage" (lpMsg as tagMSG) as long
declare sub      PostQuitMessage lib "USER32.DLL" alias "PostQuitMessage" (byval nExitCode as long)
declare function UpdateLayeredWindow lib "USER32.DLL" alias "UpdateLayeredWindow" (byval hWnd as dword, byval hdcDst as dword, pptDst as POINTAPI, psize as SIZEL, byval hdcSrc as dword, pptSrc as POINTAPI, _
                                                                                   byval crKey as dword, pblend as BLENDFUNCTION, byval dwFlags as dword) as long
declare function wglCreateContext lib "OPENGL32.DLL" alias "wglCreateContext" (byval hdc as dword) as dword
declare function wglDeleteContext lib "OPENGL32.DLL" alias "wglDeleteContext" (byval hglrc as dword) as long
declare function wglMakeCurrent lib "OPENGL32.DLL" alias "wglMakeCurrent" (byval hdc as dword, byval hglrc as dword) as long

declare sub glMatrixMode lib "opengl32.dll" alias "glMatrixMode" (byval mode as dword)
declare function glGenLists lib "opengl32.dll" alias "glGenLists" (byval range as long) as dword
declare sub glNewList lib "opengl32.dll" alias "glNewList" (byval list as dword, byval mode as dword)
declare sub glEnable lib "opengl32.dll" alias "glEnable" (byval cap as dword)
declare sub glBindTexture lib "opengl32.dll" alias "glBindTexture" (byval ntarget as dword, byval texture as dword)
declare sub glDisable lib "opengl32.dll" alias "glDisable" (byval cap as dword)
declare function gluNewQuadric lib "glu32.dll" alias "gluNewQuadric" () as long
declare sub gluDeleteQuadric lib "glu32.dll" alias "gluDeleteQuadric" (byval state as dword)
declare sub gluQuadricNormals lib "glu32.dll" alias "gluQuadricNormals" (byval quadObject as dword, byval normals as dword)
declare sub gluQuadricTexture lib "glu32.dll" alias "gluQuadricTexture" (byval quadObject as dword, byval textureCoords as dword)
declare sub gluSphere lib "GLU32.DLL" alias "gluSphere" (byval dword, byval double, byval long, byval long)
declare function glGetError lib "opengl32.dll" alias "glGetError" () as dword
declare sub glBlendFunc lib "opengl32.dll" alias "glBlendFunc" (byval sfactor as dword, byval dfactor as dword)
declare sub glClear lib "opengl32.dll" alias "glClear" (byval mask as dword)
declare sub glClearColor lib "opengl32.dll" alias "glClearColor" (byval red as single, byval green as single, byval blue as single, byval alpha as single)
declare sub glClearDepth lib "opengl32.dll" alias "glClearDepth" (byval depth as double)
declare sub glColor4ub lib "opengl32.dll" alias "glColor4ub" (byval red as byte, byval green as byte, byval blue as byte, byval alpha as byte)
declare sub glDeleteTextures lib "opengl32.dll" alias "glDeleteTextures" (byval n as long, textures as any)
declare sub glDepthFunc lib "opengl32.dll" alias "glDepthFunc" (byval func as dword)
declare sub glEnd lib "opengl32.dll" alias "glEnd" ()
declare sub glGenTextures lib "opengl32.dll" alias "glGenTextures" (byval n as long, textures as any)
declare sub glLightfv lib "opengl32.dll" alias "glLightfv" (byval light as dword, byval pname as dword, params as any)
declare sub glRotatef lib "opengl32.dll" alias "glRotatef" (byval angle as single, byval x as single, byval y as single, byval z as single)
declare sub glShadeModel lib "opengl32.dll" alias "glShadeModel" (byval mode as dword)
declare sub glTexParameteri lib "opengl32.dll" alias "glTexParameteri" (byval ntarget as dword, byval pname as dword, byval param as long)
declare sub glTranslatef lib "opengl32.dll" alias "glTranslatef" (byval x as single, byval y as single, byval z as single)
declare sub glEndList lib "opengl32.dll" alias "glEndList" ()
declare sub glDeleteLists lib "opengl32.dll" alias "glDeleteLists" (byval list as dword, byval range as long)
declare sub glBegin lib "opengl32.dll" alias "glBegin" (byval mode as dword)
declare sub glEnd lib "opengl32.dll" alias "glEnd" ()
declare sub glCallList lib "opengl32.dll" alias "glCallList" (byval list as dword)
declare sub glPopMatrix lib "opengl32.dll" alias "glPopMatrix" ()
declare sub glPushMatrix lib "opengl32.dll" alias "glPushMatrix" ()
declare sub gluPerspective lib "glu32.dll" alias "gluPerspective" (byval fovy as double, byval aspect as double, byval zNear as double, byval zFar as double)
declare sub glViewport lib "opengl32.dll" alias "glViewport" (byval x as long, byval y as long, byval nwidth as long, byval height as long)
declare sub glTexImage2D lib "opengl32.dll" alias "glTexImage2D" (byval ntarget as dword, byval level as long, byval internalformat as long, byval nwidth as long, byval height as long, byval nborder as long, _
                                                                  byval nformat as dword, byval ntype as dword, npixels as any)

function DisplayDC() as long
    function = CreateIC("DISPLAY", byval 0, byval 0, byval 0)
end function

function GdipStart() as long
    local GpInput as GdiplusStartupInput, hGDIplus as long
    GpInput.GdiplusVersion = 1
    if (GdiplusStartup(hGDIplus, GpInput) = 0) then function = hGDIplus
end function

'// GDIPLUS unload (unload the GDIPLUS.DLL)
sub GdipEnd(byval hGDIplus as long)
  ' Unload the GDI+ Dll
    if (hGDIplus) then GdiplusShutdown(hGDIplus): hGDIplus = 0
end sub

'// Create DIB section
function CreateDIB (byval hDC as long, byval nWidth as long, byval nHeight as long, byval BitCount as long) as long
    local bi as MYBITMAPINFO
    bi.bmiHeader.biSize = sizeof(bi.bmiHeader)
    bi.bmiHeader.biWidth = nWidth
    bi.bmiHeader.biHeight = nHeight
    bi.bmiHeader.biPlanes = 1
    bi.bmiHeader.biBitCount = BitCount
    bi.bmiHeader.biCompression = %BI_RGB
    function = MyCreateDIBSection(hDC, bi, %DIB_RGB_COLORS, 0, 0, 0)
end function

'// Return width and height size of a GDIPLUS image.
sub GetImageSize (byval img as long, imgW as long, imgH as long)
    GdipGetImageWidth(img, imgW)
    GdipGetImageHeight(img, imgH)
end sub

sub SplitColorARGB (byval ARGB as long, A as byte, R as byte, G as byte, B as byte)
    dim bytestruct as COLORbyteS
    LSET bytestruct = MKL$(ARGB&)
    A? = bytestruct.A
    R? = bytestruct.R
    G? = bytestruct.G
    B? = bytestruct.B
end sub

function CreateGLTextureFromFile (zFullPath as asciiz, Xin as long, Yin as long, PixelArray() as byte, byval SquareTexture as long) as long

    local bi as MYBITMAPINFO, bm as BITMAP
    local pBits as byte PTR, rScale as single
    local K, xP, yP, xS, yS, So, hDIB, hIC, hDC, img, imgW, imgH, ImgAttr as long
    local sImgName, sPathName as STRING
    local ARGBcolor as long, A, R, G, B as byte

    Xin = 0: Yin = 0: imgW = 0: imgH = 0
    
    sImgName = UCASE$(zFullPath)

    So = instr(-1, sImgName, $Dot)
    if (So) and NOT ISFILE(sImgName) then So = 0
    if (So) then
        Imgtype$ = MID$(sImgName, So) + $Dot
        if (instr(".BMP.DIB.GIF.ICO.JPG.JPEG.PNG.TIF.TIFF.", Imgtype$)) then
            '// Load the image
            if (GdipLoadImageFromFile((ucode$(sImgName)), img) = 0) then
                '// Get the image height and width
                GetImageSize(img, imgW, imgH)
               
                dim P(1 to 12) as long
                array assign P() = 2,4,8,16,32,64,128,256,512,1024,2048,4096
                for K = ubound(P) to lbound(P) step -1
                    if ((Xin = 0) and (ImgW > P(K) - 1)) then Xin = P(K)
                    if ((Yin = 0) and (ImgH > P(K) - 1)) then Yin = P(K)
                next
               
                if ((SquareTexture) and (Xin <> Yin)) then
                    Xin = max&(Xin, Yin): Yin = Xin
                else
                    SquareTexture = 0
                end if
               
                '// Perform rScale adjustment (zIconise(imgW, imgH, Xin, Yin, xP, yP, xS, yS))
                if (imgW) then rScale = Xin / imgW
                if (rScale > 1) then rScale = 1
                xS = imgW * rScale: yS = imgH * rScale
                '// In case Height > Yin compute new rScale factor
                if (yS > Yin) then
                    if (imgH) then rScale = Yin / imgH
                    xS = imgW * rScale: yS = imgH * rScale
                end if
                xP = (Xin - xS) \ 2: yP = (Yin - yS) \ 2
                '// ------------------------------------------------------------------------
               
                hIC = DisplayDC()
                hDC = CreateCompatibleDC(hIC)
               
                bi.bmiHeader.biSize = sizeof(bi.bmiHeader)
                bi.bmiHeader.biWidth = Xin
                bi.bmiHeader.biHeight = Yin
                bi.bmiHeader.biPlanes = 1
                bi.bmiHeader.biBitCount = 32
                bi.bmiHeader.biCompression = 0 ' %BI_RGB
                hDIB = MyCreateDIBSection(hDC, bi, 0, 0, 0, 0)
               
                SelectObject(hDC, hDIB)
                '// Draw image
                if (GdipCreateFromHDC(hDC, graphics&) = 0) then
               
                   '// Set up stretching QualityMode
                   GdipSetInterpolationMode(graphics&, 2)
               
                   '// Fill the background with color of pixel(0,0)
                   if (SquareTexture) then
                       GdipBitmapGetPixel(img, 0, 0, ARGBcolor)
                       SplitColorARGB(ARGBcolor, A, R, G, B)
                       GetObject(hDIB, sizeof(bm), bm)
                       pBits = bm.bmBits
                       for K = (Xin * Yin) to 1 step - 1
                           @pBits[3] = A
                           @pBits[2] = R
                           @pBits[1] = G
                           @pBits[0] = B
                           pBits = pBits + 4
                       next
                   end if
                   
                   '// Draw image
                   if (GdipDrawImageRectRectI(graphics&, img, xP, yP, xS, yS, 0, 0, ImgW, ImgH, %UnitPixel, ImgAttr) = 0) then ' This is an optional parameter
                       bi.bmiHeader.biSize        = sizeof(bi.bmiHeader)
                       bi.bmiHeader.biWidth       = Xin
                       bi.bmiHeader.biHeight      = Yin
                       bi.bmiHeader.biPlanes      = 1
                       bi.bmiHeader.biBitCount    = 32
                       bi.bmiHeader.biCompression = 0 ' %BI_RGB
                       redim PixelArray(0 to Xin * Yin * 4 - 1) as byte
                       if (GetDIBits(hDC, hDIB, 0, Yin, PixelArray(0), byval VARPTR(bi), 0)) then
                           '//  Perform Red and Green permutation
                           pBits = VARPTR(PixelArray(0))
                           for K = (Xin * Yin) to 1 step - 1
                               R = @pBits[2]: @pBits[2] = @pBits[0]: @pBits[0] = R: pBits = pBits + 4
                           next
                           function = -1
                       end if
                   end if
                   '// Cleanup
                   GdipDeleteGraphics(graphics&)
                end if
                DeleteObject(hDIB)
                if (hDC) then DeleteDC(hDC)
                if (hIC) then DeleteDC(hIC)
            end if
            GdipDisposeImage(img): img = 0
        end if   
    end if

end function

sub MakeMultipleTexture (byval tp as BBPTEXTURE PTR, byval N as long)
    local mtCount, K, nRet, xSize, ySize, OkDelete as long
    dim mt(1 to N) as BBPTEXTURE AT tp
    mtCount = ubound(mt()) - lbound(mt()) + 1
    if (mtCount) then
        dim Texture(1 to mtCount) as long
        for K = 1 to mtCount
            Texture(K) = mt(k).Texture: if Texture(K) then OkDelete = -1
        next
        if OkDelete then glDeleteTextures(mtCount, Texture(1))
        glGenTextures(mtCount, Texture(1)): nRet = glGetError()
        if (nRet = 0) then
            for K = 1 to mtCount
                redim PixelArray(0) as byte
                if (CreateGLTextureFromFile(mt(K).FullName, xSize, ySize, PixelArray(), mt(K).Square)) then
                    mt(k).Texture = Texture(K)
                    glBindTexture(%GL_TEXTURE_2D, Texture(K)): nRet = glGetError
                    if (nRet = 0) then
                        glTexParameteri(%GL_TEXTURE_2D, %GL_TEXTURE_MAG_FILTER, %GL_LINEAR)
                        glTexParameteri(%GL_TEXTURE_2D, %GL_TEXTURE_MIN_FILTER, %GL_LINEAR)
                        glTexImage2D(%GL_TEXTURE_2D, 0, 4, xSize&, ySize&, 0, %GL_RGBA, %GL_UNSIGNED_byte, PixelArray(0))
                    end if
                end if
            next
        end if
    end if
end sub

function Rgb2Gray (byval RGBValue as dword)as dword

    !XOR ESI, ESI
    !XOR EDX, EDX
    !MOV ECX, RGBValue

    '// Red
    !MOV EAX, 19595
    !MOV DL, CL
    !MUL EDX
    !ADD ESI, EAX

    '// Green
    !MOV EAX, 38470
    !SHR ECX, 8
    !MOV DL, CL
    !MUL EDX
    !ADD ESI, EAX

    '// Blue
    !MOV EAX, 7471
    !SHR ECX, 8
    !MOV DL, CL
    !MUL EDX
    !ADD ESI, EAX

    !SHR ESI, 16
    !MOV EDX, ESI

    '// Put Gray Value to a dword (0GGG)
    !XOR EAX, EAX
    !OR AL, DL
    !SHL EAX, 8
    !OR AL, DL
    !SHL EAX, 8
    !OR AL, DL

    !MOV function, EAX

end function

sub PlayWav()
'   // Better to load from resource instead of file to limit CPU usage.
'    Playsound((EXE.Path$ + "Boing.wav"), 0&, &H1)
    Playsound("blup", GetModuleHandle(""), %SND_RESOURCE OR %SND_ASYNC)
end sub

function GLsphere(byval texture as long) as long
    local quadObj, ListID as long
    ListID = glGenLists(1)
    glNewList(ListID, %GL_COMPILE)

    glEnable (%GL_TEXTURE_2D)
    glBindTexture (%GL_TEXTURE_2D, texture)
   
    quadObj = gluNewQuadric()                   ' Pointer to the Quadric Object (Return 0 if No Memory))
    if (quadObj) then
        gluQuadricNormals(quadObj, %GLU_SMOOTH)  ' Create Smooth Normals
        gluQuadricTexture(quadObj, %GL_TRUE)     ' Create Texture Coords
        gluSphere(quadObj, 0.95, 32, 32)
        gluDeleteQuadric(quadObj)
    end if

    glDisable (%GL_TEXTURE_2D)
   
    glEndList()

    function = ListID
end function
